---
title: Set a logpoint
slug: Tools/Debugger/Set_a_logpoint
tags:
  - Debugger
  - Debugging
  - Dev Tools
  - JavaScript debugging
  - Tools
  - breakpoint
  - logpoint
---
<p>{{ToolsSidebar}}</p>

<p>Sometimes you want to view a value in your code but you don't want to pause execution. Rather than sprinkle <code><a href="/en-US/docs/Web/API/Console/log">console.log()</a></code> statements throughout your code, you can use a special type of breakpoint, the logpoint. Logpoints print a message to the Console panel instead of pausing code execution.</p>

<p>The logpoint is especially useful in cases where breaking the execution breaks testing procedures, such as when you are debugging popup windows, or executing focus-related logic.</p>

<p>To create a logpoint:</p>

<ol>
 <li>Right click on a line number in the Debugger panel and pick <strong>Add log</strong> action from the context menu.</li>
</ol>

<p><span style="background-color: transparent; color: #000000; font-family: Arial; font-size: 11pt; font-style: normal; font-variant: normal; font-weight: 400; text-decoration: none; vertical-align: baseline; white-space: pre-wrap;"><img alt="" src="https://mdn.mozillademos.org/files/16601/add_logpoint.png" style="display: block; height: 121px; margin: 0px auto; width: 241px;"></span></p>

<ol start="2">
 <li>Create an expression inline. The result is logged in the console panel every time the line with the logpoint executes. You can use any variable or function available in the current scope.</li>
</ol>

<p><span style="background-color: transparent; color: #000000; font-family: Arial; font-size: 11pt; font-style: normal; font-variant: normal; font-weight: 400; text-decoration: none; vertical-align: baseline; white-space: pre-wrap;"><img alt="" src="https://mdn.mozillademos.org/files/16646/creating_the_log_point.png" style="border: 1px solid black; display: block; height: 67px; margin: 0px auto; width: 312px;"></span></p>

<h2 id="Working_with_logpoints">Working with logpoints</h2>

<p>When you set a logpoint, the indicator is purple, rather than the blue of an unconditional breakpoint or the orange of a conditional breakpoint.</p>

<p>You can view the list of logpoints in the Breakpoints side panel.</p>

<p><img alt="" src="https://mdn.mozillademos.org/files/16645/list_logpoints.png" style="border: 1px solid black; display: block; height: 134px; margin: 0px auto; width: 845px;"></p>

<p>When execution hits a logpoint, the message you have defined is logged to the console. You can make it easier to see the message by opening a split console under the debugger. (Either press <kbd>Esc</kbd> or select the elipsis menu (<strong>...</strong>) and then click <strong>Show Split Console</strong>.)</p>

<p><img alt="" src="https://mdn.mozillademos.org/files/16644/logpoints.png" style="border: 1px solid black; display: block; height: 370px; margin: 0px auto; width: 915px;"></p>

<h3 id="When_should_you_use_logpoints">When should you use logpoints?</h3>

<ul>
 <li>When you want to know that a specific line in your code has executed, but you don’t want to break code execution, set a logpoint.</li>
 <li>Logpoints are useful to log the value of a variable at a specific point in the code. It’s faster than changing the underlying source code itself to add calls to the <code>console.log</code> method.</li>
 <li>If you need to execute additional logic related to the source code and you can’t change the source code itself, you can use a logpoint.</li>
 <li>Note that you can use logpoints with <a href="/en-US/docs/Tools/Debugger/Using_the_Debugger_map_scopes_feature">source-mapped code</a>, as well as with your unmapped source files.</li>
</ul>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Tools/Debugger/How_to/Set_a_breakpoint">Set a breakpoint</a></li>
 <li><a href="/en-US/docs/Tools/Debugger/How_to/Set_a_conditional_breakpoint">Set a conditional breakpoint</a></li>
 <li><a href="/en-US/docs/Tools/Debugger/Set_an_XHR_breakpoint">Set an XHR breakpoint</a></li>
 <li><a href="/en-US/docs/Tools/Debugger/How_to/Disable_breakpoints">Disable breakpoints</a></li>
</ul>
